package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityPatternStorage;
import ru.dbotthepony.mc.otm.menu.slot.PatternSlot;

public class PatternStorageMenu extends MatteryMenu {
	public PatternStorageMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public PatternSlot[] pattern_slots = new PatternSlot[2 * 4];

	public PatternStorageMenu(int p_38852_, Inventory inventory, BlockEntityPatternStorage tile) {
		super(Registry.Menus.PATTERN_STORAGE, p_38852_, inventory, tile);

		Container patterns = tile != null ? tile.patterns : new SimpleContainer(2 * 4);

		for (int row = 0; row < 2; row++) {
			for (int column = 0; column < 4; column++) {
				pattern_slots[row * 4 + column] = new PatternSlot(patterns, row * 4 + column, 48 + column * 20, 27 + row * 24);
				addSlot(pattern_slots[row * 4 + column]);
			}
		}

		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 2 * 4;
	}
}
