package ru.dbotthepony.mc.otm.screen;

import com.mojang.blaze3d.systems.RenderSystem;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.resources.ResourceLocation;

/**
 * Represents a texture element on atlas
 */
public record SkinElement(ResourceLocation texture, float image_x, float image_y, float rect_w, float rect_h,
                          float defined_width, float defined_height) {
	public void render(PoseStack stack, float x, float y, float width, float height) {
		RenderSystem.setShaderTexture(0, texture);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();

		RenderHelper.drawTexturedRectUV(
			stack,
			x,
			y,
			width,
			height,
			image_x / defined_width,
			image_y / defined_height,
			(image_x + rect_w) / defined_width,
			(image_y + rect_h) / defined_height);
	}

	public void render(PoseStack stack) {
		render(stack, 0, 0);
	}

	public void render(PoseStack stack, float x, float y) {
		RenderSystem.setShaderTexture(0, texture);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();

		RenderHelper.drawTexturedRectUV(
			stack,
			x,
			y,
			rect_w,
			rect_h,
			image_x / defined_width,
			image_y / defined_height,
			(image_x + rect_w) / defined_width,
			(image_y + rect_h) / defined_height);
	}

	public void renderW(PoseStack stack, float x, float y, float width) {
		RenderSystem.setShaderTexture(0, texture);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();

		RenderHelper.drawTexturedRectUV(
			stack,
			x,
			y,
			width,
			rect_h,
			image_x / defined_width,
			image_y / defined_height,
			(image_x + rect_w) / defined_width,
			(image_y + rect_h) / defined_height);
	}

	public void renderH(PoseStack stack, float x, float y, float height) {
		RenderSystem.setShaderTexture(0, texture);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();

		RenderHelper.drawTexturedRectUV(
			stack,
			x,
			y,
			rect_w,
			height,
			image_x / defined_width,
			image_y / defined_height,
			(image_x + rect_w) / defined_width,
			(image_y + rect_h) / defined_height);
	}

	public void renderRaw(PoseStack stack, float x, float y, float width, float height) {
		// RenderSystem.setShader(GameRenderer::getPositionTexShader);
		// RenderSystem.setShaderTexture(0, texture);

		RenderHelper.drawTexturedRectUV(
			stack,
			x,
			y,
			width,
			height,
			image_x / defined_width,
			image_y / defined_height,
			(image_x + rect_w) / defined_width,
			(image_y + rect_h) / defined_height);
	}

	public void renderRaw(PoseStack stack, float x, float y) {
		// RenderSystem.setShader(GameRenderer::getPositionTexShader);
		// RenderSystem.setShaderTexture(0, texture);

		RenderHelper.drawTexturedRectUV(
			stack,
			x,
			y,
			rect_w,
			rect_h,
			image_x / defined_width,
			image_y / defined_height,
			(image_x + rect_w) / defined_width,
			(image_y + rect_h) / defined_height);
	}
}
